// Chart_To_Fixed_TF.mq4

// Idea & money: RogH, https://login.mql5.com/en/users/rogh
// Code: f2011, http://www.mql5.com/en/job/new?prefered=f2011

// 6.08.2014 15:00

#property copyright "f2011"
#property strict

#include <WinUser32.mqh>
#import "user32.dll"
	int PostMessageA(int hWnd, int Msg, int wParam, int lParam);
	int GetAncestor(int hWnd, int gaFlags);
	int GetDlgItem(int i_Dialogue_Handle, int nIDDlgItem);
	int GetLastActivePopup(int hWnd);
#import

enum ENUM_TF_MINUTES {
	TF_M1		= 1,		// M1
	TF_M5		= 5,		// M5
	TF_M15	= 15,		// M15
	TF_M30	= 30,		// M30
	TF_H1		= 60,		// H1
	TF_H4		= 240,	// H4
	TF_D1		= 1440,	// D1
	TF_W1		= 10080,// W1
	TF_MN1	= 43200	// MN1
};



input ENUM_TF_MINUTES Work_Period = TF_MN1; // Work period



void OnStart() {      
	int
		i_Internal_Command, i_MT_Handle, i_Dialogue_Handle, i_Button_ID,
		i_Chart_Handle = WindowHandle(_Symbol, _Period)
	;
	i_MT_Handle = GetAncestor(i_Chart_Handle, 2); //    
	
	switch(Work_Period) {
		case TF_M1:		i_Internal_Command = 33137; break;
		case TF_M5:		i_Internal_Command = 33138; break;
		case TF_M15:	i_Internal_Command = 33139; break;
		case TF_M30:	i_Internal_Command = 33140; break;
		case TF_H1:		i_Internal_Command = 35400; break;
		case TF_H4:		i_Internal_Command = 33136; break;
		case TF_D1:		i_Internal_Command = 33134; break;
		case TF_W1:		i_Internal_Command = 33141; break;
		case TF_MN1:	i_Internal_Command = 33334; break;
		default:			i_Internal_Command = 33134; break;
	}
	
	int
		i_Symbol_Chart = 0
	;
	long
		i_Counter = 0,
		i_This_Chart_ID = ChartID(),
		i_Chart_ID = ChartFirst()
	;
	while(i_Counter++ < 100) {
		if(i_Chart_ID != i_This_Chart_ID)
			PostMessageA(WindowHandle(ChartSymbol(i_Chart_ID), ChartPeriod(i_Chart_ID)), 0x0111, i_Internal_Command, 0);
		i_Chart_ID = ChartNext(i_Chart_ID);
		if(i_Chart_ID < 0) break;
	}
	
	PostMessageA(i_Chart_Handle, 0x0111, i_Internal_Command, 0);
	Sleep(100);
	while(!IsStopped()) {
		i_Dialogue_Handle = GetLastActivePopup(i_MT_Handle); //    
		i_Button_ID = GetDlgItem(i_Dialogue_Handle, IDYES); //    ""
		PostMessageA(i_Dialogue_Handle, 0x0111, IDYES, i_Button_ID); //   
		Sleep(1000);
	}
}